import { Tag } from 'antd';
import delIcon from "@images/del.png";
import './selectedTag.less';
/****
 * 已选中的元素
 * 入参：data:[{id,name}],delTag:移除事件
 *
 * ****/
function SelectedTag(props){
    const {userData,deptData,delTag} = props;
    return (
        <div className="selected-box">
            <p className='clear-bar'>
                <span>已选中</span>
                <a onClick={()=>delTag()}><img className='back-icon' src={delIcon} alt="清空所有" /><i>清空所有</i></a>
            </p>
            <div className="selected-items">
                {userData.map((it,i)=>{
                    return (<Tag closable key={it.id} onClose={()=>delTag(i,1)}>
                        {it.name}
                    </Tag>)
                })}
                {deptData.map((it,i)=>{
                    return (<Tag closable key={it.id} onClose={()=>delTag(i,2)}>
                        {it.name}
                    </Tag>)
                })}
            </div>
        </div>
    )
}

export default SelectedTag;